enifed("glimmer-demos/index", ["exports", "glimmer-demos/lib/uptime", "glimmer-demos/lib/dbmon", "glimmer-demos/lib/conways", "glimmer-demos/lib/ripples", "glimmer-demos/lib/visualizer"], function (exports, _glimmerDemosLibUptime, _glimmerDemosLibDbmon, _glimmerDemosLibConways, _glimmerDemosLibRipples, _glimmerDemosLibVisualizer) {
  "use strict";

  var UptimeDemo = _glimmerDemosLibUptime;
  exports.UptimeDemo = UptimeDemo;
  var Dbmon = _glimmerDemosLibDbmon;
  exports.Dbmon = Dbmon;
  var RipplesDemo = _glimmerDemosLibRipples;
  exports.RipplesDemo = RipplesDemo;
  var ConwaysDemo = _glimmerDemosLibConways;
  exports.ConwaysDemo = ConwaysDemo;
  var Visualizer = _glimmerDemosLibVisualizer;
  exports.Visualizer = Visualizer;
});

enifed('glimmer-demos/lib/conways', ['exports', 'glimmer-test-helpers', 'glimmer-object-reference'], function (exports, _glimmerTestHelpers, _glimmerObjectReference) {
    'use strict';

    exports.startGlimmer = startGlimmer;
    exports.startDOM = startDOM;

    // // Bare version
    // const app = `{{#each world.cells key="key" as |cell|}}<organism-cell class="{{if cell.isAlive "alive" ""}}" style="top: {{cell.y}}0px; left: {{cell.x}}0px"/>{{/each}}`;
    // Component version
    var app = '<div class="world">{{#each world.cells key="key" as |cell|}}<organism-cell-component cell={{cell}} />{{/each}}</div>';
    var env = new _glimmerTestHelpers.TestEnvironment();
    env.registerEmberishGlimmerComponent('organism-cell-component', null, '<organism-cell class="{{if @cell.isAlive "alive" ""}}" style="top: {{@cell.y}}px; left: {{@cell.x}}px" />');
    function getWorld() {
        /* tslint:disable: no-require-imports */
        return require("worlds/one").default;
        /* tslint:enable: no-require-imports */
    }
    var res = undefined;
    var self = undefined;

    function startGlimmer() {
        var world = getWorld();
        env.begin();
        self = new _glimmerObjectReference.UpdatableReference({ world: world });
        res = env.compile(app).render(self, document.body, new _glimmerTestHelpers.TestDynamicScope());
        env.commit();
        requestAnimationFrame(rerenderGlimmer);
    }

    function rerenderGlimmer() {
        var world = getWorld();
        world.advance();
        self.update({ world: world });
        res.rerender();
        requestAnimationFrame(rerenderGlimmer);
    }

    function startDOM() {
        var world = getWorld();
        var state = {
            isAlive: [],
            elements: []
        };
        var body = document.body;
        var div = document.createElement("div");
        div.classList.add("world");
        world.forEach(function (cell, i) {
            state.isAlive[i] = cell.isAlive;
            var el = state.elements[i] = document.createElement("organism-cell");
            el.style.top = cell.y + "px";
            el.style.left = cell.x + "px";
            if (cell.isAlive) {
                el.classList.add("alive");
            }
            div.appendChild(el);
        });
        body.appendChild(div);
        function updateCell(cell, i) {
            var oldAlive = state.isAlive[i];
            var newAlive = cell.isAlive;
            var el = state.elements[i];
            if (oldAlive !== newAlive) {
                state.isAlive[i] = newAlive;
                newAlive ? el.classList.add("alive") : el.classList.remove("alive");
            }
        }
        function rerenderDOM() {
            world.advance();
            world.forEach(updateCell);
            requestAnimationFrame(rerenderDOM);
        }
        requestAnimationFrame(rerenderDOM);
    }

    window['startDOM'] = startDOM;
});

enifed('glimmer-demos/lib/dbmon', ['exports', 'glimmer-object-reference', 'glimmer-test-helpers', 'glimmer-demos/lib/ema'], function (exports, _glimmerObjectReference, _glimmerTestHelpers, _glimmerDemosLibEma) {
    'use strict';

    exports.init = init;
    exports.toggle = toggle;

    var Component = (function () {
        function Component(attrs) {
            this.element = null;
            this.attrs = attrs;
        }

        Component.create = function create(_ref) {
            var attrs = _ref.attrs;

            return new this(attrs);
        };

        Component.prototype.set = function set(key, value) {
            this[key] = value;
        };

        Component.prototype.didInitAttrs = function didInitAttrs() {};

        Component.prototype.didUpdateAttrs = function didUpdateAttrs() {};

        Component.prototype.didReceiveAttrs = function didReceiveAttrs() {};

        Component.prototype.willInsertElement = function willInsertElement() {};

        Component.prototype.willUpdate = function willUpdate() {};

        Component.prototype.willRender = function willRender() {};

        Component.prototype.didInsertElement = function didInsertElement() {};

        Component.prototype.didUpdate = function didUpdate() {};

        Component.prototype.didRender = function didRender() {};

        return Component;
    })();

    var DbmonDatabase = (function (_Component) {
        babelHelpers.inherits(DbmonDatabase, _Component);

        function DbmonDatabase() {
            _Component.apply(this, arguments);
        }

        babelHelpers.createClass(DbmonDatabase, [{
            key: 'queries',
            get: function () {
                var samples = this.attrs.db.samples;
                return samples[samples.length - 1].queries;
            }
        }, {
            key: 'topFiveQueries',
            get: function () {
                var queries = this.queries;
                var topFiveQueries = queries.slice(0, 5);
                while (topFiveQueries.length < 5) {
                    topFiveQueries.push({ query: "" });
                }
                return topFiveQueries.map(function (query, index) {
                    return {
                        key: index + '',
                        query: query.query,
                        elapsed: query.elapsed ? formatElapsed(query.elapsed) : '',
                        className: elapsedClass(query.elapsed)
                    };
                });
            }
        }, {
            key: 'countClassName',
            get: function () {
                var queries = this.queries;
                var countClassName = "label";
                if (queries.length >= 20) {
                    countClassName += " label-important";
                } else if (queries.length >= 10) {
                    countClassName += " label-warning";
                } else {
                    countClassName += " label-success";
                }
                return countClassName;
            }
        }]);
        return DbmonDatabase;
    })(Component);

    var env = new _glimmerTestHelpers.TestEnvironment();
    env.registerEmberishGlimmerComponent('dbmon-database', DbmonDatabase, '\n <tr>\n  <td class="dbname">\n  {{db.name}}\n  </td>\n  <td class="query-count">\n    <span class="{{countClassName}}">\n      {{queries.length}}\n    </span>\n  </td>\n  {{#each topFiveQueries key="key" as |query|}}\n    <td class="Query {{query.className}}">\n      {{query.elapsed}}\n      <div class="popover left">\n        <div class="popover-content">{{query.query}}</div>\n        <div class="arrow"></div>\n      </div>\n    </td>\n  {{/each}}\n </tr>\n');
    var app = env.compile('\n{{#if fps}}<div id="fps">{{fps}} FPS</div>{{/if}}\n\n<table class="table table-striped latest-data">\n  <tbody>\n    {{#each model.databaseArray key=\'name\' as |db|}}\n      {{dbmon-database db=db}}\n    {{/each}}\n  </tbody>\n</table>\n');
    var serversRef = undefined;
    var result = undefined;
    var clear = undefined;
    var fps = undefined;
    var playing = false;

    function init() {
        var output = document.getElementById('output');
        var model = generateData();
        console.time('initial render');
        env.begin();
        serversRef = new _glimmerObjectReference.UpdatableReference({ model: model });
        result = app.render(serversRef, output, new _glimmerTestHelpers.TestDynamicScope());
        console.log(env['createdComponents'].length);
        env.commit();
        console.timeEnd('initial render');
    }

    function toggle() {
        if (playing) {
            window['playpause'].innerHTML = "Play";
            cancelAnimationFrame(clear);
            clear = null;
            fps = null;
            playing = false;
        } else {
            window['playpause'].innerHTML = "Pause";
            start();
            playing = true;
        }
    }

    function start() {
        playing = true;
        env.begin();
        var lastFrame = null;
        var fpsMeter = new _glimmerDemosLibEma.default(2 / 121);
        var callback = function () {
            var thisFrame = window.performance.now();
            onFrame();
            if (lastFrame) {
                fps = Math.round(fpsMeter.push(1000 / (thisFrame - lastFrame)));
            }
            result.rerender();
            clear = requestAnimationFrame(callback);
            lastFrame = thisFrame;
        };
        callback();
        lastFrame = null;
    }
    function onFrame() {
        var model = generateData(serversRef.databaseArray);
        serversRef.update({ model: model, fps: fps });
    }
    var ROWS = 100;
    function getData() {
        // generate some dummy data
        var data = {
            start_at: new Date().getTime() / 1000,
            databases: {}
        };
        for (var i = 1; i <= ROWS; i++) {
            data.databases["cluster" + i] = {
                queries: []
            };
            data.databases["cluster" + i + "slave"] = {
                queries: []
            };
        }
        Object.keys(data.databases).forEach(function (dbname) {
            var info = data.databases[dbname];
            var r = Math.floor(Math.random() * 10 + 1);
            for (var i = 0; i < r; i++) {
                var q = {
                    canvas_action: null,
                    canvas_context_id: null,
                    canvas_controller: null,
                    canvas_hostname: null,
                    canvas_job_tag: null,
                    canvas_pid: null,
                    elapsed: Math.random() * 15,
                    query: "SELECT blah FROM something",
                    waiting: Math.random() < 0.5
                };
                if (Math.random() < 0.2) {
                    q.query = "<IDLE> in transaction";
                }
                if (Math.random() < 0.1) {
                    q.query = "vacuum";
                }
                info.queries.push(q);
            }
            info.queries = info.queries.sort(function (a, b) {
                return b.elapsed - a.elapsed;
            });
        });
        return data;
    }
    function generateData() {
        var oldData = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

        var rawData = getData();
        var databases = oldData && oldData.databases || {};
        var databaseArray = [];
        var data = { databases: databases, databaseArray: databaseArray };
        Object.keys(rawData.databases).forEach(function (dbname) {
            var sampleInfo = rawData.databases[dbname];
            if (!databases[dbname]) {
                databases[dbname] = {
                    name: dbname,
                    samples: []
                };
            }
            var samples = databases[dbname].samples;
            samples.push({
                time: rawData.start_at,
                queries: sampleInfo.queries
            });
            if (samples.length > 5) {
                samples.splice(0, samples.length - 5);
            }
            databaseArray.push(databases[dbname]);
        });
        return data;
    }
    // utils
    function elapsedClass(elapsed) {
        if (elapsed >= 10.0) {
            return "elapsed warn_long";
        } else if (elapsed >= 1.0) {
            return "elapsed warn";
        } else {
            return "elapsed short";
        }
    }
    function lpad(str, padding, toLength) {
        return padding.repeat((toLength - str.length) / padding.length).concat(str);
    }
    function formatElapsed(value) {
        var str = parseFloat(value).toFixed(2);
        if (value > 60) {
            var minutes = Math.floor(value / 60);
            var comps = (value % 60).toFixed(2).split('.');
            var seconds = lpad(comps[0], '0', 2);
            var ms = comps[1];
            str = minutes + ":" + seconds + "." + ms;
        }
        return str;
    }
});

enifed("glimmer-demos/lib/ema", ["exports"], function (exports) {
    "use strict";

    var ExponentialMovingAverage = (function () {
        function ExponentialMovingAverage(alpha) {
            this.alpha = alpha;
            this.lastValue = null;
        }

        ExponentialMovingAverage.prototype.value = function value() {
            return this.lastValue;
        };

        ExponentialMovingAverage.prototype.push = function push(dataPoint) {
            var alpha = this.alpha;
            var lastValue = this.lastValue;

            if (lastValue) {
                return this.lastValue = lastValue + alpha * (dataPoint - lastValue);
            } else {
                return this.lastValue = dataPoint;
            }
        };

        return ExponentialMovingAverage;
    })();

    exports.default = ExponentialMovingAverage;
});

enifed('glimmer-demos/lib/ripples', ['exports', 'glimmer-object-reference', 'glimmer-test-helpers'], function (exports, _glimmerObjectReference, _glimmerTestHelpers) {
    'use strict';

    exports.start = start;

    function RingBuffer(capacity) {
        this.capacity = capacity;
        this.head = 0;
        this.items = new Array(capacity);
        this.length = 0;
    }
    RingBuffer.prototype.push = function (item) {
        this.items[this.head] = item;
        this.length++;
        this.head++;
        this.head %= this.capacity;
    };
    RingBuffer.prototype.remove = function (i) {
        this.length--;
        this.items[i] = undefined;
    };
    RingBuffer.prototype.forEach = function (callback, thisArg) {
        for (var i = 0, l = this.items.length; i < l; i++) {
            if (this.items[i] === undefined) continue;
            callback.call(thisArg, this.items[i], i);
        }
    };
    function Point(timestamp, x, y) {
        this.key = null;
        this.timestamp = timestamp;
        this.x = x;
        this.y = y;
        this.size = 0.0;
        this.opacity = 1.0;
    }
    ;
    Point.prototype.update = function (index, currentTimestamp) {
        var delta = currentTimestamp - this.timestamp;
        this.size = Math.max(delta / 10, 0);
        this.opacity = Math.exp(-delta / 250);
        this.key = String(index);
    };

    function start() {
        var env = new _glimmerTestHelpers.TestEnvironment();
        var TEMPLATES = {};
        Array.prototype.slice.call(document.querySelectorAll("[data-template-name]")).forEach(function (node) {
            var name = node.getAttribute("data-template-name"),
                source = node.textContent;
            TEMPLATES[name] = env.compile(source);
        });
        var data = {
            width: window.innerWidth,
            height: window.innerHeight,
            points: new RingBuffer(500),
            count: 0
        };
        var output = document.getElementById('output');
        var self = new _glimmerObjectReference.UpdatableReference(data);
        var result = TEMPLATES['application'].render(self, env, { appendTo: output });
        window.addEventListener("resize", function () {
            data.width = window.innerWidth;
            data.height = window.innerHeight;
        });
        document.addEventListener("mousemove", function (e) {
            data.points.push(new Point(window.performance.now(), e.layerX, e.layerY));
        });
        function tick() {
            var timestamp = window.performance.now();
            data.count = 0;
            data.points.forEach(function (point, i) {
                if (point) {
                    point.update(i, timestamp);
                    if (point.opacity > 0.001) {
                        data.count++;
                    } else {
                        data.points.remove(i);
                    }
                }
            });
            self.update(data);
            result.rerender();
            window.requestAnimationFrame(tick);
        }
        tick();
    }
});

enifed('glimmer-demos/lib/uptime', ['exports', 'glimmer-object-reference', 'glimmer-test-helpers', 'glimmer-demos/lib/ema'], function (exports, _glimmerObjectReference, _glimmerTestHelpers, _glimmerDemosLibEma) {
    'use strict';

    exports.init = init;
    exports.toggle = toggle;

    var Component = (function () {
        function Component(attrs) {
            this.element = null;
            this.attrs = attrs;
        }

        Component.create = function create(_ref) {
            var attrs = _ref.attrs;

            return new this(attrs);
        };

        Component.prototype.set = function set(key, value) {
            this[key] = value;
        };

        Component.prototype.didInitAttrs = function didInitAttrs() {};

        Component.prototype.didUpdateAttrs = function didUpdateAttrs() {};

        Component.prototype.didReceiveAttrs = function didReceiveAttrs() {};

        Component.prototype.willInsertElement = function willInsertElement() {};

        Component.prototype.willUpdate = function willUpdate() {};

        Component.prototype.willRender = function willRender() {};

        Component.prototype.didInsertElement = function didInsertElement() {};

        Component.prototype.didUpdate = function didUpdate() {};

        Component.prototype.didRender = function didRender() {};

        return Component;
    })();

    var ServerUptime = (function (_Component) {
        babelHelpers.inherits(ServerUptime, _Component);

        function ServerUptime() {
            _Component.apply(this, arguments);
        }

        babelHelpers.createClass(ServerUptime, [{
            key: 'upDays',
            get: function () {
                return this.attrs.days.reduce(function (upDays, day) {
                    return upDays += day.up ? 1 : 0;
                }, 0);
            }
        }, {
            key: 'streak',
            get: function () {
                var _attrs$days$reduce = this.attrs.days.reduce(function (_ref2, day) {
                    var max = _ref2[0];
                    var streak = _ref2[1];

                    if (day.up && streak + 1 > max) {
                        return [streak + 1, streak + 1];
                    } else if (day.up) {
                        return [max, streak + 1];
                    } else {
                        return [max, 0];
                    }
                }, [0, 0]);

                var max = _attrs$days$reduce[0];

                return max;
            }
        }]);
        return ServerUptime;
    })(Component);

    var UptimeDay = (function (_Component2) {
        babelHelpers.inherits(UptimeDay, _Component2);

        function UptimeDay() {
            _Component2.apply(this, arguments);
        }

        babelHelpers.createClass(UptimeDay, [{
            key: 'color',
            get: function () {
                return this.attrs.day.up ? '#8cc665' : '#ccc';
            }
        }, {
            key: 'memo',
            get: function () {
                return this.attrs.day.up ? 'Servers operational!' : 'Red alert!';
            }
        }]);
        return UptimeDay;
    })(Component);

    var env = new _glimmerTestHelpers.TestEnvironment();
    env.registerEmberishGlimmerComponent('uptime-day', UptimeDay, '\n  <div class="uptime-day">\n    <span class="uptime-day-status" style="background-color: {{color}}" />\n    <span class="hover">{{@day.number}}: {{memo}}</span>\n  </div>\n');
    env.registerEmberishGlimmerComponent('server-uptime', ServerUptime, '\n  <div class="server-uptime">\n    <h1>{{@name}}</h1>\n    <h2>{{upDays}} Days Up</h2>\n    <h2>Biggest Streak: {{streak}}</h2>\n\n    <div class="days">\n      {{#each @days key="number" as |day|}}\n        <uptime-day @day={{day}} />\n      {{/each}}\n    </div>\n  </div>\n');
    var app = env.compile('\n  {{#if fps}}<div id="fps">{{fps}} FPS</div>{{/if}}\n\n  {{#each servers key="name" as |server|}}\n    <server-uptime @name={{server.name}} @days={{server.days}} />\n  {{/each}}\n');
    var serversRef = undefined;
    var result = undefined;
    var clear = undefined;
    var fps = undefined;
    var playing = false;

    function init() {
        var output = document.getElementById('output');
        console.time('initial render');
        env.begin();
        serversRef = new _glimmerObjectReference.UpdatableReference({ servers: generateServers(), fps: null });
        result = app.render(serversRef, output, new _glimmerTestHelpers.TestDynamicScope());
        console.log(env['createdComponents'].length);
        env.commit();
        console.timeEnd('initial render');
    }

    function toggle() {
        if (playing) {
            window['playpause'].innerHTML = "Play";
            cancelAnimationFrame(clear);
            clear = null;
            fps = null;
            playing = false;
        } else {
            window['playpause'].innerHTML = "Pause";
            start();
            playing = true;
        }
    }

    function start() {
        playing = true;
        var lastFrame = null;
        var fpsMeter = new _glimmerDemosLibEma.default(2 / 121);
        var callback = function () {
            var thisFrame = window.performance.now();
            if (lastFrame) {
                fps = Math.round(fpsMeter.push(1000 / (thisFrame - lastFrame)));
            }
            onFrame();
            result.rerender();
            clear = requestAnimationFrame(callback);
            lastFrame = thisFrame;
        };
        callback();
        lastFrame = null;
    }
    function onFrame() {
        serversRef.update({ servers: generateServers(), fps: fps });
    }
    function generateServer(name) {
        var days = [];
        for (var i = 0; i <= 364; i++) {
            var up = Math.random() > 0.2;
            days.push({ number: i, up: up });
        }
        return { name: name, days: days };
    }
    function generateServers() {
        return [generateServer("Stefan's Server"), generateServer("Godfrey's Server"), generateServer("Yehuda's Server")];
    }
});

enifed('glimmer-demos/lib/visualizer', ['exports', 'glimmer-test-helpers', 'glimmer-object-reference', 'glimmer-compiler', 'glimmer-runtime'], function (exports, _glimmerTestHelpers, _glimmerObjectReference, _glimmerCompiler, _glimmerRuntime) {
  'use strict';

  exports.init = init;

  var DEFAULT_DATA = '{\n  "contacts": [\n    {\n      "id": 1,\n      "name": {\n        "first": "John",\n        "last": "Appleseed"\n      },\n      "org": "Apple Inc.",\n      "email": "appleseed@apple.com",\n      "address": {\n        "street": "1 Infinite Loop",\n        "city": "Cupertino",\n        "state": "CA",\n        "zip": 95014,\n        "country": "USA"\n      },\n      "phones": [\n        {\n          "type": "Office",\n          "number": "1 (800) MYAPPLE"\n        },\n        {\n          "type": "Home",\n          "number": "(555) 123 4567"\n        },\n        {\n          "type": "Mobile",\n          "number": "(555) 555 5555"\n        }\n      ]\n    }\n  ]\n}';
  var DEFAULT_TEMPLATE = '<div class="contacts">\n  {{#each contacts key="id" as |contact|}}\n    <h-card @person={{contact}} />\n    <hr />\n  {{/each}}\n</div>';
  var DEFAULT_LAYOUT = '<div class="vcard">\n  {{#if @person.url}}\n    <div>\n      <a class="url fn n" href="{{@person.url}}">\n      {{#with @person.name as |name|}}\n        <span class="given-name">{{name.first}}</span>\n        {{#if name.middle}}\n        <span class="additional-name">{{name.middle}}</span>\n        {{/if}}\n        <span class="family-name">{{name.last}}</span>\n      {{/with}}\n      </a>\n    </div>\n  {{else}}\n    <div>\n      {{#with @person.name as |name|}}\n        <span class="given-name">{{name.first}}</span>\n        {{#if name.additional}}\n        <span class="additional-name">{{name.middle}}</span>\n        {{/if}}\n        <span class="family-name">{{name.last}}</span>\n      {{/with}}\n    </div>\n  {{/if}}\n  {{#if @person.org}}\n    <div class="org">{{@person.org}}</div>\n  {{/if}}\n  {{#if @person.email}}\n    <div>\n      <a class="email" href="mailto:{{@person.email}}">\n        {{@person.email}}\n      </a>\n    </div>\n  {{/if}}\n  {{#with @person.address as |address|}}\n    <div class="adr">\n      <span class="street-address">{{address.street}}</span>\n      <br>\n      <span class="locality">{{address.city}}</span>,\n      <span class="region">{{address.state}}</span>\n      <span class="postal-code">{{address.zip}}</span>\n      <br>\n      <span class="country-name">{{address.country}}</span>\n    </div>\n  {{/with}}\n  {{#each @person.phones key="type" as |phone|}}\n    <div class="tel">\n      <span class="type">{{phone.type}}</span>:\n      <span class="value">{{phone.number}}</span>\n    </div>\n  {{/each}}\n</div>';
  var UI = '<div id="inputs" class="{{if rendered \'\' \'full-width\'}}">\n  <h1>\n    <span style="font-size: 48px; color: rgb(238, 89, 57);">Glimmer</span>\n    <span style="font-size: 40px; color: rgb(161, 63, 43);">Visualizer</span>\n  </h1>\n\n  <div class="input-group">\n    <label for="data">Data</label>\n    <textarea id="data" wrap="off">{{data}}</textarea>\n  </div>\n\n  <div class="input-group">\n    <label for="top-level-template">Top-Level Template</label>\n    <textarea id="top-level-template" wrap="off" readOnly={{if rendered true false}}>{{template.source}}</textarea>\n  </div>\n\n  <div class="input-group">\n    <label for="component-layout">&lt;h-card&gt; Layout</label>\n    <textarea id="component-layout" wrap="off" readOnly={{if rendered true false}}>{{layout.source}}</textarea>\n  </div>\n\n  <button id="btn-render" class="primary" style="display: {{if rendered \'none\' \'block\'}}">Render</button>\n  <button id="btn-update" class="primary" style="display: {{if rendered \'block\' \'none\'}}">Update</button>\n  <button id="btn-edit" style="display: {{if rendered \'block\' \'none\'}}">Edit</button>\n  <button id="btn-reset">Reset</button>\n</div>\n{{#if rendered}}\n  <div id="output">\n    <div id="wire-format">\n      <div class="header">Wire Format (Top-Level)</div>\n      <wire-format-inspector class="content" @spec={{template.wireFormat}} />\n      <div class="header secondary">Wire Format (&lt;h-card&gt;)</div>\n      <wire-format-inspector class="content" @spec={{layout.wireFormat}} />\n    </div>\n    <div id="initial">\n      <div class="header">Opcodes (Top-Level)</div>\n      <div class="content">\n        <h3>Opcodes</h3>\n        <ol>\n          {{#each template.opcodes key="guid" as |opcode|}}\n            <opcode-inspector @opcode={{opcode}} />\n          {{/each}}\n        </ol>\n      </div>\n      <div class="header secondary">Opcodes (&lt;h-card&gt;)</div>\n      <div class="content">\n        <h3>Opcodes</h3>\n        <ol>\n          {{#each layout.opcodes key="guid" as |opcode|}}\n            <opcode-inspector @opcode={{opcode}} />\n          {{/each}}\n        </ol>\n      </div>\n    </div>\n    <div id="updating">\n      <div class="header">Updating Opcodes</div>\n      <div class="content full-height">\n        <h3>Opcodes</h3>\n        <ol>\n          {{#each updatingOpcodes key="guid" as |opcode|}}\n            <opcode-inspector @opcode={{opcode}} />\n          {{/each}}\n        </ol>\n      </div>\n    </div>\n    <div id="dom">\n      <div class="header">DOM</div>\n      <div class="content rendered">{{{html}}}</div>\n      <div class="header secondary">HTML</div>\n      <pre class="content secondary source">{{html}}</pre>\n    </div>\n  </div>\n{{/if}}';
  function compile(str, env) {
    var spec = JSON.parse(_glimmerCompiler.precompile(str, {}));
    var factory = _glimmerRuntime.templateFactory(spec);
    return factory.create(env);
  }
  var $inputs = undefined,
      $data = undefined,
      $template = undefined,
      $layout = undefined,
      $render = undefined,
      $update = undefined,
      $edit = undefined,
      $reset = undefined;
  var ui = {
    rendered: false,
    data: DEFAULT_DATA,
    template: {
      source: DEFAULT_TEMPLATE,
      wireFormat: null,
      opcodes: null
    },
    layout: {
      source: DEFAULT_LAYOUT,
      wireFormat: null,
      opcodes: null
    },
    updatingOpcodes: null,
    html: ""
  };

  function init() {
    renderUI();
    bindUI();
    wireUI();
  }

  var rerenderUI = undefined;
  function renderUI() {
    var env = new _glimmerTestHelpers.TestEnvironment();
    env.registerHelper("json", function (_ref) {
      var value = _ref[0];
      return JSON.stringify(value);
    });
    env.registerEmberishGlimmerComponent("wire-format-inspector", null, '<div>\n  <h3>Statements</h3>\n  <ol>\n    {{#each @spec.statements key="@index" as |statement|}}\n      <li><span class="pre">{{json statement}}</span></li>\n    {{/each}}\n  </ol>\n  <hr />\n  {{#if @spec.locals}}\n    <h3>Locals</h3>\n    <ol>\n      {{#each @spec.locals key="@index" as |local|}}\n        <li><span class="pre">{{json local}}</span></li>\n      {{/each}}\n    </ol>\n    <hr />\n  {{/if}}\n  {{#if @spec.named}}\n    <h3>Named</h3>\n    <ol>\n      {{#each @spec.named key="@index" as |name|}}\n        <li><span class="pre">{{json name}}</span></li>\n      {{/each}}\n    </ol>\n    <hr />\n  {{/if}}\n  {{#if @spec.yields}}\n    <h3>Yields</h3>\n    <ol>\n      {{#each @spec.yields key="@index" as |yield|}}\n        <li><span class="pre">{{json yield}}</span></li>\n      {{/each}}\n    </ol>\n    <hr />\n  {{/if}}\n  {{#if @spec.blocks}}\n    <h3>Blocks</h3>\n    <ol>\n      {{#each @spec.blocks key="@index" as |block|}}\n        <li>\n          <h3>Block</h3>\n          <wire-format-inspector @spec={{block}} />\n        </li>\n      {{/each}}\n    </ol>\n  {{/if}}\n</div>');
    env.registerHelper("pp-opcode", function (_ref2) {
      var opcode = _ref2[0];

      var output = opcode.type.toUpperCase();
      if (opcode.args || opcode.details) {
        output += "(";
        if (opcode.args && opcode.args.length) {
          output += opcode.args.join(", ");
        }
        if (opcode.details) {
          var keys = Object.keys(opcode.details);
          if (keys.length) {
            if (opcode.args && opcode.args.length) {
              output += ", ";
            }
            output += keys.map(function (key) {
              return key + '=' + opcode.details[key];
            }).join(", ");
            ;
          }
        }
        output += ")";
      }
      return output;
    });
    env.registerEmberishGlimmerComponent("opcode-inspector", null, '<li>\n  <span class="pre">{{#if @opcode.deopted}}[DEOPT] <del>{{pp-opcode @opcode}}</del>{{else}}{{pp-opcode @opcode}}{{/if}}</span>\n  {{#if @opcode.children}}\n    <ol>\n      {{#each @opcode.children key="guid" as |opcode|}}\n        <opcode-inspector @opcode={{opcode}} />\n      {{/each}}\n    </ol>\n  {{/if}}\n</li>');
    env.begin();
    var self = new _glimmerObjectReference.UpdatableReference(ui);
    var res = env.compile(UI).render(self, document.body, new _glimmerTestHelpers.TestDynamicScope());
    env.commit();
    rerenderUI = function () {
      self.update(ui);
      env.begin();
      res.rerender();
      env.commit();
    };
  }
  function bindUI() {
    $inputs = document.querySelectorAll("#inputs")[0];
    $data = document.querySelectorAll("#data")[0];
    $template = document.querySelectorAll("#top-level-template")[0];
    $layout = document.querySelectorAll("#component-layout")[0];
    $render = document.querySelectorAll("#btn-render")[0];
    $update = document.querySelectorAll("#btn-update")[0];
    $edit = document.querySelectorAll("#btn-edit")[0];
    $reset = document.querySelectorAll("#btn-reset")[0];
  }
  function wireUI() {
    $render.addEventListener("click", renderContent, false);
    $update.addEventListener("click", updateContent, false);
    $edit.addEventListener("click", editContent, false);
    $reset.addEventListener("click", resetContent, false);
    $data.addEventListener("input", storeContent);
    $template.addEventListener("input", storeContent);
    $layout.addEventListener("input", storeContent);
    initContent();
  }
  function initContent() {
    var _getInitialContent = getInitialContent();

    var data = _getInitialContent.data;
    var template = _getInitialContent.template;
    var layout = _getInitialContent.layout;

    $data.value = data;
    $template.value = template;
    $layout.value = layout;
  }
  var _updateContent = null;
  function renderContent() {
    var data = JSON.parse($data.value);
    var env = new _glimmerTestHelpers.TestEnvironment();
    env.registerHelper('foo-bar', function () {
      return 'FOO BAR!!!';
    });
    env.registerEmberishGlimmerComponent("h-card", null, $layout.value);
    var app = env.compile($template.value);
    function compileLayout(component) {
      var definition = env.getComponentDefinition([component]);
      var manager = definition.manager;
      var instance = manager.create(env, definition, _glimmerRuntime.EvaluatedArgs.empty(), new _glimmerTestHelpers.TestDynamicScope(), null, false);
      var compiled = manager.layoutFor(definition, instance, env);
      return compiled.ops;
    }
    function eagerCompile(ops) {
      ops.toArray().forEach(function (op) {
        if (op.block) {
          eagerCompile(op.block.compile(env).ops);
        }
      });
      return ops;
    }
    function toJSON(ops) {
      return ops.toArray().map(function (op) {
        return op.toJSON();
      });
    }
    var div = document.createElement('div');
    env.begin();
    var self = new _glimmerObjectReference.UpdatableReference(data);
    var res = app.render(self, div, new _glimmerTestHelpers.TestDynamicScope());
    env.commit();
    var entryPoint = app.asEntryPoint();
    var templateOps = entryPoint.compile(env).ops;
    var layoutOps = compileLayout("h-card");
    ui.rendered = true;
    ui.template.source = $template.value;
    ui.template.wireFormat = compile($template.value, env)._block;
    ui.template.opcodes = toJSON(eagerCompile(templateOps));
    ui.layout.source = $layout.value;
    ui.layout.wireFormat = compile($layout.value, env)._block;
    ui.layout.opcodes = toJSON(eagerCompile(layoutOps));
    ui.updatingOpcodes = toJSON(res['updating']);
    ui.html = div.innerHTML;
    window['$UI'] = ui;
    window['$DIV'] = div;
    _updateContent = function () {
      self.update(JSON.parse($data.value));
      env.begin();
      res.rerender();
      env.commit();
      ui.template.opcodes = toJSON(eagerCompile(templateOps));
      ui.layout.opcodes = toJSON(eagerCompile(layoutOps));
      ui.updatingOpcodes = toJSON(res['updating']);
      ui.html = div.innerHTML;
      rerenderUI();
    };
    rerenderUI();
  }
  function updateContent() {
    _updateContent();
  }
  function editContent() {
    _updateContent = null;
    ui.rendered = false;
    rerenderUI();
  }
  function getInitialContent() {
    return getStoredContent() || {
      data: DEFAULT_DATA,
      template: DEFAULT_TEMPLATE,
      layout: DEFAULT_LAYOUT
    };
  }
  function getStoredContent() {
    var content = localStorage.getItem('glimmer-visualizer:content');
    if (content) {
      return JSON.parse(content);
    }
  }
  function storeContent() {
    localStorage.setItem('glimmer-visualizer:content', JSON.stringify({
      data: $data.value,
      template: $template.value,
      layout: $layout.value
    }));
  }
  function resetContent() {
    $data.value = DEFAULT_DATA;
    $template.value = DEFAULT_TEMPLATE;
    $layout.value = DEFAULT_LAYOUT;
    storeContent();
    editContent();
  }
});

enifed('glimmer-test-helpers/index', ['exports', 'glimmer-test-helpers/lib/helpers', 'glimmer-test-helpers/lib/environment', 'glimmer-test-helpers/lib/abstract-test-case'], function (exports, _glimmerTestHelpersLibHelpers, _glimmerTestHelpersLibEnvironment, _glimmerTestHelpersLibAbstractTestCase) {
  'use strict';

  exports.compile = _glimmerTestHelpersLibHelpers.compile;
  exports.compileLayout = _glimmerTestHelpersLibHelpers.compileLayout;
  exports.equalInnerHTML = _glimmerTestHelpersLibHelpers.equalInnerHTML;
  exports.equalHTML = _glimmerTestHelpersLibHelpers.equalHTML;
  exports.equalTokens = _glimmerTestHelpersLibHelpers.equalTokens;
  exports.generateSnapshot = _glimmerTestHelpersLibHelpers.generateSnapshot;
  exports.equalSnapshots = _glimmerTestHelpersLibHelpers.equalSnapshots;
  exports.normalizeInnerHTML = _glimmerTestHelpersLibHelpers.normalizeInnerHTML;
  exports.isCheckedInputHTML = _glimmerTestHelpersLibHelpers.isCheckedInputHTML;
  exports.getTextContent = _glimmerTestHelpersLibHelpers.getTextContent;
  exports.strip = _glimmerTestHelpersLibHelpers.strip;
  exports.stripTight = _glimmerTestHelpersLibHelpers.stripTight;
  exports.Attrs = _glimmerTestHelpersLibEnvironment.Attrs;
  exports.BasicComponent = _glimmerTestHelpersLibEnvironment.BasicComponent;
  exports.EmberishCurlyComponent = _glimmerTestHelpersLibEnvironment.EmberishCurlyComponent;
  exports.EmberishGlimmerComponent = _glimmerTestHelpersLibEnvironment.EmberishGlimmerComponent;
  exports.TestModifierManager = _glimmerTestHelpersLibEnvironment.TestModifierManager;
  exports.TestEnvironment = _glimmerTestHelpersLibEnvironment.TestEnvironment;
  exports.TestDynamicScope = _glimmerTestHelpersLibEnvironment.TestDynamicScope;
  exports.equalsElement = _glimmerTestHelpersLibEnvironment.equalsElement;
  exports.inspectHooks = _glimmerTestHelpersLibEnvironment.inspectHooks;
  exports.regex = _glimmerTestHelpersLibEnvironment.regex;
  exports.classes = _glimmerTestHelpersLibEnvironment.classes;
  exports.VersionedObject = _glimmerTestHelpersLibAbstractTestCase.VersionedObject;
  exports.testModule = _glimmerTestHelpersLibAbstractTestCase.testModule;
  exports.template = _glimmerTestHelpersLibAbstractTestCase.template;
  exports.RenderingTest = _glimmerTestHelpersLibAbstractTestCase.RenderingTest;
  exports.SimpleRootReference = _glimmerTestHelpersLibAbstractTestCase.SimpleRootReference;
});

enifed('glimmer-test-helpers/lib/abstract-test-case', ['exports', 'glimmer-reference', 'glimmer-test-helpers/lib/environment', 'glimmer-test-helpers/lib/helpers'], function (exports, _glimmerReference, _glimmerTestHelpersLibEnvironment, _glimmerTestHelpersLibHelpers) {
    'use strict';

    exports.skip = skip;
    exports.testModule = testModule;
    exports.template = template;

    function skip(target, name, descriptor) {
        descriptor.value['skip'] = true;
    }

    var VersionedObject = (function () {
        function VersionedObject(value) {
            this.tag = new _glimmerReference.DirtyableTag();
            _glimmerTestHelpersLibHelpers.assign(this, value);
        }

        VersionedObject.prototype.update = function update(value) {
            _glimmerTestHelpersLibHelpers.assign(this, value);
            this.dirty();
        };

        VersionedObject.prototype.set = function set(key, value) {
            this[key] = value;
            this.dirty();
        };

        VersionedObject.prototype.dirty = function dirty() {
            this.tag.dirty();
        };

        return VersionedObject;
    })();

    exports.VersionedObject = VersionedObject;

    var SimpleRootReference = (function () {
        function SimpleRootReference(object) {
            this.object = object;
            this.tag = object.tag;
        }

        SimpleRootReference.prototype.get = function get(key) {
            return new SimplePathReference(this, key);
        };

        SimpleRootReference.prototype.value = function value() {
            return this.object;
        };

        return SimpleRootReference;
    })();

    exports.SimpleRootReference = SimpleRootReference;

    var SimplePathReference = (function () {
        function SimplePathReference(parent, key) {
            this.parent = parent;
            this.key = key;
            this.tag = parent.tag;
        }

        SimplePathReference.prototype.get = function get(key) {
            return new SimplePathReference(this, key);
        };

        SimplePathReference.prototype.value = function value() {
            return this.parent.value()[this.key];
        };

        return SimplePathReference;
    })();

    function isMarker(node) {
        if (node instanceof Comment && node.textContent === '') {
            return true;
        }
        if (node instanceof Text && node.textContent === '') {
            return true;
        }
        return false;
    }

    var RenderingTest = (function () {
        function RenderingTest(env, template, appendTo) {
            if (env === undefined) env = new _glimmerTestHelpersLibEnvironment.TestEnvironment();

            this.env = env;
            this.appendTo = appendTo;
            this.context = null;
            this.result = null;
            this.template = this.env.compile(template);
            this.assert = QUnit.config.current.assert;
        }

        RenderingTest.prototype.teardown = function teardown() {};

        RenderingTest.prototype.render = function render(context) {
            var dynamicScope = new _glimmerTestHelpersLibEnvironment.TestDynamicScope();
            var appendTo = this.appendTo;
            var rootObject = new VersionedObject(context);
            var root = new SimpleRootReference(rootObject);
            this.context = rootObject;
            this.result = this.template.render(root, appendTo, dynamicScope);
            this.element = document.getElementById('qunit-fixture').firstChild;
        };

        RenderingTest.prototype.assertContent = function assertContent(expected, message) {
            var actual = document.getElementById('qunit-fixture').innerHTML;
            QUnit.equal(actual, expected);
        };

        RenderingTest.prototype.takeSnapshot = function takeSnapshot() {
            var snapshot = this.snapshot = [];
            var node = this.element.firstChild;
            while (node) {
                if (!isMarker(node)) {
                    snapshot.push(node);
                }
                node = node.nextSibling;
            }
            return snapshot;
        };

        RenderingTest.prototype.assertStableRerender = function assertStableRerender() {
            this.takeSnapshot();
            this.rerender();
            this.assertInvariants();
        };

        RenderingTest.prototype.rerender = function rerender() {
            this.result.rerender();
        };

        RenderingTest.prototype.assertInvariants = function assertInvariants(oldSnapshot, newSnapshot) {
            oldSnapshot = oldSnapshot || this.snapshot;
            newSnapshot = newSnapshot || this.takeSnapshot();
            this.assert.strictEqual(newSnapshot.length, oldSnapshot.length, 'Same number of nodes');
            for (var i = 0; i < oldSnapshot.length; i++) {
                this.assertSameNode(newSnapshot[i], oldSnapshot[i]);
            }
        };

        RenderingTest.prototype.assertSameNode = function assertSameNode(actual, expected) {
            this.assert.strictEqual(actual, expected, 'DOM node stability');
        };

        RenderingTest.prototype.runTask = function runTask(callback) {
            callback();
            this.result.rerender();
        };

        return RenderingTest;
    })();

    exports.RenderingTest = RenderingTest;

    function testModule(description) {
        return function (TestClass) {
            var context = undefined;
            QUnit.module('[Browser] ' + (description || TestClass.name), {
                teardown: function () {
                    context.teardown();
                }
            });
            var keys = Object.getOwnPropertyNames(TestClass.prototype);
            keys.forEach(function (key) {
                if (key === 'constructor') return;
                var value = Object.getOwnPropertyDescriptor(TestClass.prototype, key).value;
                var isSkipped = value.skip;
                if (typeof value === 'function' && !isSkipped) {
                    QUnit.test(key, function (assert) {
                        var env = new _glimmerTestHelpersLibEnvironment.TestEnvironment();
                        context = new TestClass(env, value['template'], document.getElementById('qunit-fixture'));
                        value.call(context, assert);
                    });
                } else if (isSkipped) {
                    QUnit.skip(key, function () {});
                }
            });
        };
    }

    function template(t) {
        return function template(target, name, descriptor) {
            if (typeof descriptor.value !== 'function') {
                throw new Error("Can't decorator a non-function with the @template decorator");
            }
            descriptor.value['template'] = t;
        };
    }
});

enifed("glimmer-test-helpers/lib/environment", ["exports", "glimmer-runtime", "glimmer-test-helpers/lib/helpers", "glimmer-util", "glimmer-object", "glimmer-reference", "glimmer-object-reference"], function (exports, _glimmerRuntime, _glimmerTestHelpersLibHelpers, _glimmerUtil, _glimmerObject, _glimmerReference, _glimmerObjectReference) {
    "use strict";

    exports.inspectHooks = inspectHooks;
    exports.equalsElement = equalsElement;
    exports.equalsAttr = equalsAttr;
    exports.equals = equals;
    exports.regex = regex;
    exports.classes = classes;

    var ArrayIterator = (function () {
        function ArrayIterator(array, keyFor) {
            this.position = 0;
            this.array = array;
            this.keyFor = keyFor;
        }

        ArrayIterator.prototype.isEmpty = function isEmpty() {
            return this.array.length === 0;
        };

        ArrayIterator.prototype.next = function next() {
            var position = this.position;
            var array = this.array;
            var keyFor = this.keyFor;

            if (position >= array.length) return null;
            var value = array[position];
            var key = keyFor(value, position);
            var memo = position;
            this.position++;
            return { key: key, value: value, memo: memo };
        };

        return ArrayIterator;
    })();

    var ObjectKeysIterator = (function () {
        function ObjectKeysIterator(keys, values, keyFor) {
            this.position = 0;
            this.keys = keys;
            this.values = values;
            this.keyFor = keyFor;
        }

        ObjectKeysIterator.prototype.isEmpty = function isEmpty() {
            return this.keys.length === 0;
        };

        ObjectKeysIterator.prototype.next = function next() {
            var position = this.position;
            var keys = this.keys;
            var values = this.values;
            var keyFor = this.keyFor;

            if (position >= keys.length) return null;
            var value = values[position];
            var memo = keys[position];
            var key = keyFor(value, memo);
            this.position++;
            return { key: key, value: value, memo: memo };
        };

        return ObjectKeysIterator;
    })();

    var EmptyIterator = (function () {
        function EmptyIterator() {}

        EmptyIterator.prototype.isEmpty = function isEmpty() {
            return true;
        };

        EmptyIterator.prototype.next = function next() {
            throw new Error("Cannot call next() on an empty iterator");
        };

        return EmptyIterator;
    })();

    var EMPTY_ITERATOR = new EmptyIterator();

    var Iterable = (function () {
        function Iterable(ref, keyFor) {
            this.tag = ref.tag;
            this.ref = ref;
            this.keyFor = keyFor;
        }

        Iterable.prototype.iterate = function iterate() {
            var ref = this.ref;
            var keyFor = this.keyFor;

            var iterable = ref.value();
            if (Array.isArray(iterable)) {
                return iterable.length > 0 ? new ArrayIterator(iterable, keyFor) : EMPTY_ITERATOR;
            } else if (iterable === undefined || iterable === null) {
                return EMPTY_ITERATOR;
            } else if (iterable.forEach !== undefined) {
                var _ret = (function () {
                    var array = [];
                    iterable.forEach(function (item) {
                        array.push(item);
                    });
                    return {
                        v: array.length > 0 ? new ArrayIterator(array, keyFor) : EMPTY_ITERATOR
                    };
                })();

                if (typeof _ret === "object") return _ret.v;
            } else if (typeof iterable === 'object') {
                var keys = Object.keys(iterable);
                return keys.length > 0 ? new ObjectKeysIterator(keys, keys.map(function (key) {
                    return iterable[key];
                }), keyFor) : EMPTY_ITERATOR;
            } else {
                throw new Error("Don't know how to {{#each " + iterable + "}}");
            }
        };

        Iterable.prototype.valueReferenceFor = function valueReferenceFor(item) {
            return new _glimmerObjectReference.UpdatableReference(item.value);
        };

        Iterable.prototype.updateValueReference = function updateValueReference(reference, item) {
            reference.update(item.value);
        };

        Iterable.prototype.memoReferenceFor = function memoReferenceFor(item) {
            return new _glimmerObjectReference.UpdatableReference(item.memo);
        };

        Iterable.prototype.updateMemoReference = function updateMemoReference(reference, item) {
            reference.update(item.memo);
        };

        return Iterable;
    })();

    var BasicComponent = function BasicComponent(attrs) {
        this.attrs = attrs;
    };

    exports.BasicComponent = BasicComponent;

    var EmberishCurlyComponent = (function (_GlimmerObject) {
        babelHelpers.inherits(EmberishCurlyComponent, _GlimmerObject);

        function EmberishCurlyComponent() {
            _GlimmerObject.apply(this, arguments);
            this.dirtinessTag = new _glimmerReference.DirtyableTag();
            this.tagName = null;
            this.attributeBindings = null;
            this.parentView = null;
        }

        EmberishCurlyComponent.create = function create(args) {
            return _GlimmerObject.create.call(this, args);
        };

        EmberishCurlyComponent.prototype.recompute = function recompute() {
            this.dirtinessTag.dirty();
        };

        EmberishCurlyComponent.prototype.didInitAttrs = function didInitAttrs(options) {};

        EmberishCurlyComponent.prototype.didUpdateAttrs = function didUpdateAttrs(diff) {};

        EmberishCurlyComponent.prototype.didReceiveAttrs = function didReceiveAttrs(diff) {};

        EmberishCurlyComponent.prototype.willInsertElement = function willInsertElement() {};

        EmberishCurlyComponent.prototype.willUpdate = function willUpdate() {};

        EmberishCurlyComponent.prototype.willRender = function willRender() {};

        EmberishCurlyComponent.prototype.didInsertElement = function didInsertElement() {};

        EmberishCurlyComponent.prototype.didUpdate = function didUpdate() {};

        EmberishCurlyComponent.prototype.didRender = function didRender() {};

        return EmberishCurlyComponent;
    })(_glimmerObject.default);

    exports.EmberishCurlyComponent = EmberishCurlyComponent;

    var EmberishGlimmerComponent = (function (_GlimmerObject2) {
        babelHelpers.inherits(EmberishGlimmerComponent, _GlimmerObject2);

        function EmberishGlimmerComponent() {
            _GlimmerObject2.apply(this, arguments);
            this.dirtinessTag = new _glimmerReference.DirtyableTag();
            this.parentView = null;
        }

        EmberishGlimmerComponent.create = function create(args) {
            return _GlimmerObject2.create.call(this, args);
        };

        EmberishGlimmerComponent.prototype.recompute = function recompute() {
            this.dirtinessTag.dirty();
        };

        EmberishGlimmerComponent.prototype.didInitAttrs = function didInitAttrs(options) {};

        EmberishGlimmerComponent.prototype.didUpdateAttrs = function didUpdateAttrs(diff) {};

        EmberishGlimmerComponent.prototype.didReceiveAttrs = function didReceiveAttrs(diff) {};

        EmberishGlimmerComponent.prototype.willInsertElement = function willInsertElement() {};

        EmberishGlimmerComponent.prototype.willUpdate = function willUpdate() {};

        EmberishGlimmerComponent.prototype.willRender = function willRender() {};

        EmberishGlimmerComponent.prototype.didInsertElement = function didInsertElement() {};

        EmberishGlimmerComponent.prototype.didUpdate = function didUpdate() {};

        EmberishGlimmerComponent.prototype.didRender = function didRender() {};

        return EmberishGlimmerComponent;
    })(_glimmerObject.default);

    exports.EmberishGlimmerComponent = EmberishGlimmerComponent;

    var BasicComponentManager = (function () {
        function BasicComponentManager() {}

        BasicComponentManager.prototype.prepareArgs = function prepareArgs(definition, args) {
            return args;
        };

        BasicComponentManager.prototype.create = function create(environment, definition, args) {
            var klass = definition.ComponentClass || BasicComponent;
            return new klass(args.named.value());
        };

        BasicComponentManager.prototype.layoutFor = function layoutFor(definition, component, env) {
            var layout = env.compiledLayouts[definition.name];
            if (layout) {
                return layout;
            }
            return env.compiledLayouts[definition.name] = _glimmerRuntime.compileLayout(new BasicComponentLayoutCompiler(definition.layoutString), env);
        };

        BasicComponentManager.prototype.getSelf = function getSelf(component) {
            return new _glimmerObjectReference.UpdatableReference(component);
        };

        BasicComponentManager.prototype.didCreateElement = function didCreateElement(component, element) {
            component.element = element;
        };

        BasicComponentManager.prototype.didRenderLayout = function didRenderLayout(component, bounds) {
            component.bounds = bounds;
        };

        BasicComponentManager.prototype.didCreate = function didCreate() {};

        BasicComponentManager.prototype.getTag = function getTag() {
            return null;
        };

        BasicComponentManager.prototype.update = function update(component, attrs) {
            component.attrs = attrs.named.value();
        };

        BasicComponentManager.prototype.didUpdateLayout = function didUpdateLayout() {};

        BasicComponentManager.prototype.didUpdate = function didUpdate() {};

        BasicComponentManager.prototype.getDestructor = function getDestructor() {
            return null;
        };

        return BasicComponentManager;
    })();

    var BASIC_COMPONENT_MANAGER = new BasicComponentManager();

    var StaticTaglessComponentManager = (function (_BasicComponentManager) {
        babelHelpers.inherits(StaticTaglessComponentManager, _BasicComponentManager);

        function StaticTaglessComponentManager() {
            _BasicComponentManager.apply(this, arguments);
        }

        StaticTaglessComponentManager.prototype.layoutFor = function layoutFor(definition, component, env) {
            var layout = env.compiledLayouts[definition.name];
            if (layout) {
                return layout;
            }
            return env.compiledLayouts[definition.name] = _glimmerRuntime.compileLayout(new StaticTaglessComponentLayoutCompiler(definition.layoutString), env);
        };

        return StaticTaglessComponentManager;
    })(BasicComponentManager);

    var STATIC_TAGLESS_COMPONENT_MANAGER = new StaticTaglessComponentManager();
    var BaseEmberishGlimmerComponent = EmberishGlimmerComponent.extend();

    var EmberishGlimmerComponentManager = (function () {
        function EmberishGlimmerComponentManager() {}

        EmberishGlimmerComponentManager.prototype.prepareArgs = function prepareArgs(definition, args) {
            return args;
        };

        EmberishGlimmerComponentManager.prototype.create = function create(environment, definition, args, dynamicScope, callerSelf, hasDefaultBlock) {
            var klass = definition.ComponentClass || BaseEmberishGlimmerComponent;
            var attrs = args.named.value();
            var component = klass.create({ attrs: attrs });
            component.didInitAttrs({ attrs: attrs });
            component.didReceiveAttrs({ oldAttrs: null, newAttrs: attrs });
            component.willInsertElement();
            component.willRender();
            return component;
        };

        EmberishGlimmerComponentManager.prototype.layoutFor = function layoutFor(definition, component, env) {
            if (env.compiledLayouts[definition.name]) {
                return env.compiledLayouts[definition.name];
            }
            return env.compiledLayouts[definition.name] = _glimmerRuntime.compileLayout(new EmberishGlimmerComponentLayoutCompiler(definition.layoutString), env);
        };

        EmberishGlimmerComponentManager.prototype.getSelf = function getSelf(component) {
            return new _glimmerObjectReference.UpdatableReference(component);
        };

        EmberishGlimmerComponentManager.prototype.didCreateElement = function didCreateElement(component, element) {
            component.element = element;
        };

        EmberishGlimmerComponentManager.prototype.didRenderLayout = function didRenderLayout(component, bounds) {
            component.bounds = bounds;
        };

        EmberishGlimmerComponentManager.prototype.didCreate = function didCreate(component) {
            component.didInsertElement();
            component.didRender();
        };

        EmberishGlimmerComponentManager.prototype.getTag = function getTag(component) {
            return component.dirtinessTag;
        };

        EmberishGlimmerComponentManager.prototype.update = function update(component, args) {
            var oldAttrs = component.attrs;
            var newAttrs = args.named.value();
            component.set('attrs', newAttrs);
            component.didUpdateAttrs({ oldAttrs: oldAttrs, newAttrs: newAttrs });
            component.didReceiveAttrs({ oldAttrs: oldAttrs, newAttrs: newAttrs });
            component.willUpdate();
            component.willRender();
        };

        EmberishGlimmerComponentManager.prototype.didUpdateLayout = function didUpdateLayout() {};

        EmberishGlimmerComponentManager.prototype.didUpdate = function didUpdate(component) {
            component.didUpdate();
            component.didRender();
        };

        EmberishGlimmerComponentManager.prototype.getDestructor = function getDestructor(component) {
            return component;
        };

        return EmberishGlimmerComponentManager;
    })();

    var ProcessedArgs = (function () {
        function ProcessedArgs(args, positionalParamsDefinition) {
            this.tag = args.tag;
            this.named = args.named;
            this.positional = args.positional;
            this.positionalParamNames = positionalParamsDefinition;
        }

        ProcessedArgs.prototype.value = function value() {
            var named = this.named;
            var positional = this.positional;
            var positionalParamNames = this.positionalParamNames;

            var merged = Object.assign({}, named.value());
            if (positionalParamNames && positionalParamNames.length) {
                for (var i = 0; i < positionalParamNames.length; i++) {
                    var _name = positionalParamNames[i];
                    var reference = positional.at(i);
                    merged[_name] = reference.value();
                }
            }
            return {
                attrs: merged,
                props: merged
            };
        };

        return ProcessedArgs;
    })();

    exports.ProcessedArgs = ProcessedArgs;

    function processArgs(args, positionalParamsDefinition) {
        return new ProcessedArgs(args, positionalParamsDefinition);
    }
    var EMBERISH_GLIMMER_COMPONENT_MANAGER = new EmberishGlimmerComponentManager();
    var BaseEmberishCurlyComponent = EmberishCurlyComponent.extend();

    var EmberishCurlyComponentManager = (function () {
        function EmberishCurlyComponentManager() {}

        EmberishCurlyComponentManager.prototype.prepareArgs = function prepareArgs(definition, args) {
            return args;
        };

        EmberishCurlyComponentManager.prototype.create = function create(environment, definition, args, dynamicScope, callerSelf) {
            var klass = definition.ComponentClass || BaseEmberishCurlyComponent;
            var processedArgs = processArgs(args, klass['positionalParams']);

            var _processedArgs$value = processedArgs.value();

            var attrs = _processedArgs$value.attrs;

            var self = callerSelf.value();
            var merged = _glimmerUtil.assign({}, attrs, { attrs: attrs }, { args: processedArgs }, { targetObject: self });
            var component = klass.create(merged);
            component.didInitAttrs({ attrs: attrs });
            component.didReceiveAttrs({ oldAttrs: null, newAttrs: attrs });
            component.willInsertElement();
            component.willRender();
            return component;
        };

        EmberishCurlyComponentManager.prototype.layoutFor = function layoutFor(definition, component, env) {
            var layout = env.compiledLayouts[definition.name];
            if (layout) {
                return layout;
            }
            var layoutString = definition.layoutString;
            var lateBound = !layoutString;
            if (!layoutString && layoutString !== '') {
                layoutString = component['layout'];
            }
            layout = _glimmerRuntime.compileLayout(new EmberishCurlyComponentLayoutCompiler(layoutString), env);
            return lateBound ? layout : env.compiledLayouts[definition.name] = layout;
        };

        EmberishCurlyComponentManager.prototype.getSelf = function getSelf(component) {
            return new _glimmerObjectReference.UpdatableReference(component);
        };

        EmberishCurlyComponentManager.prototype.didCreateElement = function didCreateElement(component, element, operations) {
            component.element = element;
            var bindings = component.attributeBindings;
            var rootRef = new _glimmerObjectReference.UpdatableReference(component);
            if (bindings) {
                for (var i = 0; i < bindings.length; i++) {
                    var attribute = bindings[i];
                    var reference = rootRef.get(attribute);
                    operations.addDynamicAttribute(element, attribute, reference, false);
                }
            }
        };

        EmberishCurlyComponentManager.prototype.didRenderLayout = function didRenderLayout(component, bounds) {
            component.bounds = bounds;
        };

        EmberishCurlyComponentManager.prototype.didCreate = function didCreate(component) {
            component.didInsertElement();
            component.didRender();
        };

        EmberishCurlyComponentManager.prototype.getTag = function getTag(component) {
            return component.dirtinessTag;
        };

        EmberishCurlyComponentManager.prototype.update = function update(component, args) {
            var oldAttrs = component.attrs;
            var newAttrs = component.args.value().attrs;
            var merged = _glimmerUtil.assign({}, newAttrs, { attrs: newAttrs });
            component.setProperties(merged);
            component.didUpdateAttrs({ oldAttrs: oldAttrs, newAttrs: newAttrs });
            component.didReceiveAttrs({ oldAttrs: oldAttrs, newAttrs: newAttrs });
            component.willUpdate();
            component.willRender();
        };

        EmberishCurlyComponentManager.prototype.didUpdateLayout = function didUpdateLayout() {};

        EmberishCurlyComponentManager.prototype.didUpdate = function didUpdate(component) {
            component.didUpdate();
            component.didRender();
        };

        EmberishCurlyComponentManager.prototype.getDestructor = function getDestructor(component) {
            return component;
        };

        return EmberishCurlyComponentManager;
    })();

    var EMBERISH_CURLY_COMPONENT_MANAGER = new EmberishCurlyComponentManager();
    function emberToBool(value) {
        if (Array.isArray(value)) {
            return value.length > 0;
        } else {
            return !!value;
        }
    }

    var EmberishConditionalReference = (function (_ConditionalReference) {
        babelHelpers.inherits(EmberishConditionalReference, _ConditionalReference);

        function EmberishConditionalReference() {
            _ConditionalReference.apply(this, arguments);
        }

        EmberishConditionalReference.prototype.toBool = function toBool(value) {
            return emberToBool(value);
        };

        return EmberishConditionalReference;
    })(_glimmerRuntime.ConditionalReference);

    var SimplePathReference = (function () {
        function SimplePathReference(parent, property) {
            this.tag = _glimmerReference.VOLATILE_TAG;
            this.parent = parent;
            this.property = property;
        }

        SimplePathReference.prototype.value = function value() {
            return this.parent.value()[this.property];
        };

        SimplePathReference.prototype.get = function get(prop) {
            return new SimplePathReference(this, prop);
        };

        return SimplePathReference;
    })();

    exports.SimplePathReference = SimplePathReference;

    var HelperReference = (function () {
        function HelperReference(helper, args) {
            this.tag = _glimmerReference.VOLATILE_TAG;
            this.helper = helper;
            this.args = args;
        }

        HelperReference.prototype.value = function value() {
            var helper = this.helper;
            var _args = this.args;
            var positional = _args.positional;
            var named = _args.named;

            return helper(positional.value(), named.value());
        };

        HelperReference.prototype.get = function get(prop) {
            return new SimplePathReference(this, prop);
        };

        return HelperReference;
    })();

    var InertModifierManager = (function () {
        function InertModifierManager() {}

        InertModifierManager.prototype.create = function create() {};

        InertModifierManager.prototype.install = function install(modifier) {};

        InertModifierManager.prototype.update = function update(modifier) {};

        InertModifierManager.prototype.getDestructor = function getDestructor(modifier) {
            return null;
        };

        return InertModifierManager;
    })();

    var TestModifier = function TestModifier(element, args, dom) {
        this.element = element;
        this.args = args;
        this.dom = dom;
    };

    exports.TestModifier = TestModifier;

    var TestModifierManager = (function () {
        function TestModifierManager() {
            this.installedElements = [];
            this.updatedElements = [];
            this.destroyedModifiers = [];
        }

        TestModifierManager.prototype.create = function create(element, args, dynamicScope, dom) {
            return new TestModifier(element, args, dom);
        };

        TestModifierManager.prototype.install = function install(_ref) {
            var element = _ref.element;
            var args = _ref.args;
            var dom = _ref.dom;

            this.installedElements.push(element);
            var param = args.positional.at(0).value();
            dom.setAttribute(element, 'data-modifier', "installed - " + param);
            return;
        };

        TestModifierManager.prototype.update = function update(_ref2) {
            var element = _ref2.element;
            var args = _ref2.args;
            var dom = _ref2.dom;

            this.updatedElements.push(element);
            var param = args.positional.at(0).value();
            dom.setAttribute(element, 'data-modifier', "updated - " + param);
            return;
        };

        TestModifierManager.prototype.getDestructor = function getDestructor(modifier) {
            var _this = this;

            return {
                destroy: function () {
                    _this.destroyedModifiers.push(modifier);
                    var element = modifier.element;
                    var dom = modifier.dom;

                    dom.removeAttribute(element, 'data-modifier');
                }
            };
        };

        return TestModifierManager;
    })();

    exports.TestModifierManager = TestModifierManager;

    var TestEnvironment = (function (_Environment) {
        babelHelpers.inherits(TestEnvironment, _Environment);

        function TestEnvironment() {
            var options = arguments.length <= 0 || arguments[0] === undefined ? {
                document: document,
                appendOperations: new _glimmerRuntime.DOMTreeConstruction(document)
            } : arguments[0];

            _Environment.call(this, { appendOperations: options.appendOperations, updateOperations: new _glimmerRuntime.DOMChanges(options.document) });
            this.helpers = _glimmerUtil.dict();
            this.modifiers = _glimmerUtil.dict();
            this.partials = _glimmerUtil.dict();
            this.components = _glimmerUtil.dict();
            this.compiledLayouts = _glimmerUtil.dict();
            this.uselessAnchor = options.document.createElement('a');
            this.registerHelper("if", function (_ref3) {
                var cond = _ref3[0];
                var yes = _ref3[1];
                var no = _ref3[2];
                return cond ? yes : no;
            });
            this.registerHelper("unless", function (_ref4) {
                var cond = _ref4[0];
                var yes = _ref4[1];
                var no = _ref4[2];
                return cond ? no : yes;
            });
            this.registerInternalHelper("-get-dynamic-var", _glimmerRuntime.getDynamicVar);
            this.registerModifier("action", new InertModifierManager());
            this.registerInternalHelper("component", function (vm, args, symbolTable) {
                return new DynamicComponentReference(args.positional.at(0), vm.env, symbolTable);
            });
            this.registerInternalHelper("hash", function (vm, args) {
                return args.named;
            });
        }

        TestEnvironment.prototype.protocolForURL = function protocolForURL(url) {
            this.uselessAnchor.href = url;
            return this.uselessAnchor.protocol;
        };

        TestEnvironment.prototype.registerHelper = function registerHelper(name, helper) {
            this.helpers[name] = function (vm, args) {
                return new HelperReference(helper, args);
            };
        };

        TestEnvironment.prototype.registerInternalHelper = function registerInternalHelper(name, helper) {
            this.helpers[name] = helper;
        };

        TestEnvironment.prototype.registerModifier = function registerModifier(name, modifier) {
            this.modifiers[name] = modifier;
        };

        TestEnvironment.prototype.registerPartial = function registerPartial(name, source) {
            this.partials[name] = new _glimmerRuntime.PartialDefinition(name, _glimmerTestHelpersLibHelpers.compile(source, { env: this }));
        };

        TestEnvironment.prototype.registerComponent = function registerComponent(name, definition) {
            this.components[name] = definition;
            return definition;
        };

        TestEnvironment.prototype.registerBasicComponent = function registerBasicComponent(name, Component, layout) {
            var definition = new BasicComponentDefinition(name, BASIC_COMPONENT_MANAGER, Component, layout);
            return this.registerComponent(name, definition);
        };

        TestEnvironment.prototype.registerStaticTaglessComponent = function registerStaticTaglessComponent(name, Component, layout) {
            var definition = new StaticTaglessComponentDefinition(name, STATIC_TAGLESS_COMPONENT_MANAGER, Component, layout);
            return this.registerComponent(name, definition);
        };

        TestEnvironment.prototype.registerEmberishCurlyComponent = function registerEmberishCurlyComponent(name, Component, layout) {
            var definition = new EmberishCurlyComponentDefinition(name, EMBERISH_CURLY_COMPONENT_MANAGER, Component, layout);
            return this.registerComponent(name, definition);
        };

        TestEnvironment.prototype.registerEmberishGlimmerComponent = function registerEmberishGlimmerComponent(name, Component, layout) {
            var definition = new EmberishGlimmerComponentDefinition(name, EMBERISH_GLIMMER_COMPONENT_MANAGER, Component, layout);
            return this.registerComponent(name, definition);
        };

        TestEnvironment.prototype.toConditionalReference = function toConditionalReference(reference) {
            if (_glimmerReference.isConst(reference)) {
                return new _glimmerRuntime.ValueReference(emberToBool(reference.value()));
            }
            return new EmberishConditionalReference(reference);
        };

        TestEnvironment.prototype.refineStatement = function refineStatement(statement, symbolTable) {
            var appendType = statement.appendType;
            var isSimple = statement.isSimple;
            var isBlock = statement.isBlock;
            var isInline = statement.isInline;
            var key = statement.key;
            var args = statement.args;
            var path = statement.path;
            var templates = statement.templates;

            if (isSimple && isBlock) {
                switch (key) {
                    case 'identity':
                        return new IdentitySyntax({ args: args, templates: templates });
                    case 'render-inverse':
                        return new RenderInverseIdentitySyntax({ args: args, templates: templates });
                    case '-with-dynamic-vars':
                        return new _glimmerRuntime.WithDynamicVarsSyntax({ args: args, templates: templates });
                    case '-in-element':
                        return new _glimmerRuntime.InElementSyntax({ args: args, templates: templates });
                }
            }
            if (isSimple && (isInline || isBlock)) {
                if (key === 'component') {
                    return new DynamicComponentSyntax({ args: args, templates: templates, symbolTable: symbolTable });
                }
                var component = this.getComponentDefinition(path, symbolTable);
                if (component) {
                    return new CurlyComponentSyntax({ args: args, definition: component, templates: templates, symbolTable: symbolTable });
                }
            }
            if (!isSimple && appendType === 'unknown') {
                return statement.original.deopt();
            }
            return _Environment.prototype.refineStatement.call(this, statement, symbolTable);
        };

        TestEnvironment.prototype.hasHelper = function hasHelper(helperName) {
            return helperName.length === 1 && helperName[0] in this.helpers;
        };

        TestEnvironment.prototype.lookupHelper = function lookupHelper(helperParts) {
            var helperName = helperParts[0];
            var helper = this.helpers[helperName];
            if (!helper) throw new Error("Helper for " + helperParts.join('.') + " not found.");
            return helper;
        };

        TestEnvironment.prototype.hasPartial = function hasPartial(partialName) {
            return partialName in this.partials;
        };

        TestEnvironment.prototype.lookupPartial = function lookupPartial(partialName) {
            var partial = this.partials[partialName];
            return partial;
        };

        TestEnvironment.prototype.hasComponentDefinition = function hasComponentDefinition(name) {
            return !!this.components[name[0]];
        };

        TestEnvironment.prototype.getComponentDefinition = function getComponentDefinition(name, blockMeta) {
            return this.components[name[0]];
        };

        TestEnvironment.prototype.hasModifier = function hasModifier(modifierName) {
            return modifierName.length === 1 && modifierName[0] in this.modifiers;
        };

        TestEnvironment.prototype.lookupModifier = function lookupModifier(modifierName) {
            var name = modifierName[0];

            var modifier = this.modifiers[name];
            if (!modifier) throw new Error("Modifier for " + modifierName.join('.') + " not found.");
            return modifier;
        };

        TestEnvironment.prototype.compile = function compile(template) {
            return _glimmerTestHelpersLibHelpers.compile(template, { env: this });
        };

        TestEnvironment.prototype.compileLayout = function compileLayout(template) {
            return _glimmerTestHelpersLibHelpers.compileLayout(template, { env: this });
        };

        TestEnvironment.prototype.iterableFor = function iterableFor(ref, args) {
            var keyPath = args.named.get("key").value();
            var keyFor = undefined;
            if (!keyPath) {
                throw new Error('Must specify a key for #each');
            }
            switch (keyPath) {
                case '@index':
                    keyFor = function (_, index) {
                        return String(index);
                    };
                    break;
                case '@primitive':
                    keyFor = function (item) {
                        return String(item);
                    };
                    break;
                default:
                    keyFor = function (item) {
                        return item[keyPath];
                    };
                    break;
            }
            return new Iterable(ref, keyFor);
        };

        return TestEnvironment;
    })(_glimmerRuntime.Environment);

    exports.TestEnvironment = TestEnvironment;

    var TestDynamicScope = (function () {
        function TestDynamicScope() {}

        TestDynamicScope.prototype.get = function get(key) {
            return this[key];
        };

        TestDynamicScope.prototype.set = function set(key, reference) {
            return this[key] = reference;
        };

        TestDynamicScope.prototype.child = function child() {
            return new TestDynamicScope();
        };

        return TestDynamicScope;
    })();

    exports.TestDynamicScope = TestDynamicScope;

    var CurlyComponentSyntax = (function (_StatementSyntax) {
        babelHelpers.inherits(CurlyComponentSyntax, _StatementSyntax);

        function CurlyComponentSyntax(_ref5) {
            var args = _ref5.args;
            var definition = _ref5.definition;
            var templates = _ref5.templates;
            var symbolTable = _ref5.symbolTable;

            _StatementSyntax.call(this);
            this.type = "curly-component";
            this.shadow = null;
            this.args = args;
            this.definition = definition;
            this.templates = templates || _glimmerRuntime.Templates.empty();
            this.symbolTable = symbolTable;
        }

        CurlyComponentSyntax.prototype.compile = function compile(b, env) {
            b.component.static(this.definition, this.args, this.templates, this.symbolTable, this.shadow);
        };

        return CurlyComponentSyntax;
    })(_glimmerRuntime.StatementSyntax);

    var DynamicComponentReference = (function () {
        function DynamicComponentReference(nameRef, env, symbolTable) {
            this.nameRef = nameRef;
            this.env = env;
            this.symbolTable = symbolTable;
            this.tag = nameRef.tag;
        }

        DynamicComponentReference.prototype.value = function value() {
            var env = this.env;
            var nameRef = this.nameRef;

            var name = nameRef.value();
            if (typeof name === 'string') {
                return env.getComponentDefinition([name], this.symbolTable);
            } else {
                return null;
            }
        };

        DynamicComponentReference.prototype.get = function get() {
            return null;
        };

        return DynamicComponentReference;
    })();

    function dynamicComponentFor(vm, symbolTable) {
        var args = vm.getArgs();
        var nameRef = args.positional.at(0);
        var env = vm.env;
        return new DynamicComponentReference(nameRef, env, symbolTable);
    }
    ;

    var DynamicComponentSyntax = (function (_StatementSyntax2) {
        babelHelpers.inherits(DynamicComponentSyntax, _StatementSyntax2);

        function DynamicComponentSyntax(_ref6) {
            var args = _ref6.args;
            var templates = _ref6.templates;
            var symbolTable = _ref6.symbolTable;

            _StatementSyntax2.call(this);
            this.type = "dynamic-component";
            this.shadow = null;
            this.definitionArgs = _glimmerRuntime.ArgsSyntax.fromPositionalArgs(args.positional.slice(0, 1));
            this.definition = dynamicComponentFor;
            this.args = _glimmerRuntime.ArgsSyntax.build(args.positional.slice(1), args.named);
            this.templates = templates || _glimmerRuntime.Templates.empty();
            this.symbolTable = symbolTable;
        }

        DynamicComponentSyntax.prototype.compile = function compile(b, env) {
            b.component.dynamic(this.definitionArgs, this.definition, this.args, this.templates, this.symbolTable, this.shadow);
        };

        return DynamicComponentSyntax;
    })(_glimmerRuntime.StatementSyntax);

    var GenericComponentDefinition = (function (_ComponentDefinition) {
        babelHelpers.inherits(GenericComponentDefinition, _ComponentDefinition);

        function GenericComponentDefinition(name, manager, ComponentClass, layout) {
            _ComponentDefinition.call(this, name, manager, ComponentClass);
            this.layoutString = layout;
        }

        return GenericComponentDefinition;
    })(_glimmerRuntime.ComponentDefinition);

    exports.GenericComponentDefinition = GenericComponentDefinition;

    var BasicComponentDefinition = (function (_GenericComponentDefinition) {
        babelHelpers.inherits(BasicComponentDefinition, _GenericComponentDefinition);

        function BasicComponentDefinition() {
            _GenericComponentDefinition.apply(this, arguments);
        }

        return BasicComponentDefinition;
    })(GenericComponentDefinition);

    exports.BasicComponentDefinition = BasicComponentDefinition;

    var StaticTaglessComponentDefinition = (function (_GenericComponentDefinition2) {
        babelHelpers.inherits(StaticTaglessComponentDefinition, _GenericComponentDefinition2);

        function StaticTaglessComponentDefinition() {
            _GenericComponentDefinition2.apply(this, arguments);
        }

        return StaticTaglessComponentDefinition;
    })(GenericComponentDefinition);

    var EmberishCurlyComponentDefinition = (function (_GenericComponentDefinition3) {
        babelHelpers.inherits(EmberishCurlyComponentDefinition, _GenericComponentDefinition3);

        function EmberishCurlyComponentDefinition() {
            _GenericComponentDefinition3.apply(this, arguments);
        }

        return EmberishCurlyComponentDefinition;
    })(GenericComponentDefinition);

    exports.EmberishCurlyComponentDefinition = EmberishCurlyComponentDefinition;

    var EmberishGlimmerComponentDefinition = (function (_GenericComponentDefinition4) {
        babelHelpers.inherits(EmberishGlimmerComponentDefinition, _GenericComponentDefinition4);

        function EmberishGlimmerComponentDefinition() {
            _GenericComponentDefinition4.apply(this, arguments);
        }

        return EmberishGlimmerComponentDefinition;
    })(GenericComponentDefinition);

    exports.EmberishGlimmerComponentDefinition = EmberishGlimmerComponentDefinition;

    var GenericComponentLayoutCompiler = (function () {
        function GenericComponentLayoutCompiler(layoutString) {
            this.layoutString = layoutString;
        }

        GenericComponentLayoutCompiler.prototype.compileLayout = function compileLayout(env) {
            return _glimmerTestHelpersLibHelpers.compileLayout(this.layoutString, { env: env });
        };

        return GenericComponentLayoutCompiler;
    })();

    var BasicComponentLayoutCompiler = (function (_GenericComponentLayoutCompiler) {
        babelHelpers.inherits(BasicComponentLayoutCompiler, _GenericComponentLayoutCompiler);

        function BasicComponentLayoutCompiler() {
            _GenericComponentLayoutCompiler.apply(this, arguments);
        }

        BasicComponentLayoutCompiler.prototype.compile = function compile(builder) {
            builder.fromLayout(this.compileLayout(builder.env));
        };

        return BasicComponentLayoutCompiler;
    })(GenericComponentLayoutCompiler);

    var StaticTaglessComponentLayoutCompiler = (function (_GenericComponentLayoutCompiler2) {
        babelHelpers.inherits(StaticTaglessComponentLayoutCompiler, _GenericComponentLayoutCompiler2);

        function StaticTaglessComponentLayoutCompiler() {
            _GenericComponentLayoutCompiler2.apply(this, arguments);
        }

        StaticTaglessComponentLayoutCompiler.prototype.compile = function compile(builder) {
            builder.wrapLayout(this.compileLayout(builder.env));
        };

        return StaticTaglessComponentLayoutCompiler;
    })(GenericComponentLayoutCompiler);

    function EmberTagName(vm) {
        var self = vm.getSelf().value();
        var tagName = self['tagName'];
        tagName = tagName === '' ? null : self['tagName'] || 'div';
        return new _glimmerRuntime.ValueReference(tagName);
    }
    function EmberID(vm) {
        var self = vm.getSelf().value();
        return new _glimmerRuntime.ValueReference("ember" + self._guid);
    }

    var EmberishCurlyComponentLayoutCompiler = (function (_GenericComponentLayoutCompiler3) {
        babelHelpers.inherits(EmberishCurlyComponentLayoutCompiler, _GenericComponentLayoutCompiler3);

        function EmberishCurlyComponentLayoutCompiler() {
            _GenericComponentLayoutCompiler3.apply(this, arguments);
        }

        EmberishCurlyComponentLayoutCompiler.prototype.compile = function compile(builder) {
            builder.wrapLayout(this.compileLayout(builder.env));
            builder.tag.dynamic(EmberTagName);
            builder.attrs.static('class', 'ember-view');
            builder.attrs.dynamic('id', EmberID);
        };

        return EmberishCurlyComponentLayoutCompiler;
    })(GenericComponentLayoutCompiler);

    var EmberishGlimmerComponentLayoutCompiler = (function (_GenericComponentLayoutCompiler4) {
        babelHelpers.inherits(EmberishGlimmerComponentLayoutCompiler, _GenericComponentLayoutCompiler4);

        function EmberishGlimmerComponentLayoutCompiler() {
            _GenericComponentLayoutCompiler4.apply(this, arguments);
        }

        EmberishGlimmerComponentLayoutCompiler.prototype.compile = function compile(builder) {
            builder.fromLayout(this.compileLayout(builder.env));
            builder.attrs.static('class', 'ember-view');
            builder.attrs.dynamic('id', EmberID);
        };

        return EmberishGlimmerComponentLayoutCompiler;
    })(GenericComponentLayoutCompiler);

    function inspectHooks(ComponentClass) {
        return ComponentClass.extend({
            init: function () {
                this._super.apply(this, arguments);
                this.hooks = {
                    didInitAttrs: 0,
                    didUpdateAttrs: 0,
                    didReceiveAttrs: 0,
                    willInsertElement: 0,
                    willUpdate: 0,
                    willRender: 0,
                    didInsertElement: 0,
                    didUpdate: 0,
                    didRender: 0
                };
            },
            didInitAttrs: function () {
                this._super.apply(this, arguments);
                this.hooks['didInitAttrs']++;
            },
            didUpdateAttrs: function () {
                this._super.apply(this, arguments);
                this.hooks['didUpdateAttrs']++;
            },
            didReceiveAttrs: function () {
                this._super.apply(this, arguments);
                this.hooks['didReceiveAttrs']++;
            },
            willInsertElement: function () {
                this._super.apply(this, arguments);
                this.hooks['willInsertElement']++;
            },
            willUpdate: function () {
                this._super.apply(this, arguments);
                this.hooks['willUpdate']++;
            },
            willRender: function () {
                this._super.apply(this, arguments);
                this.hooks['willRender']++;
            },
            didInsertElement: function () {
                this._super.apply(this, arguments);
                this.hooks['didInsertElement']++;
            },
            didUpdate: function () {
                this._super.apply(this, arguments);
                this.hooks['didUpdate']++;
            },
            didRender: function () {
                this._super.apply(this, arguments);
                this.hooks['didRender']++;
            }
        });
    }

    var IdentitySyntax = (function (_StatementSyntax3) {
        babelHelpers.inherits(IdentitySyntax, _StatementSyntax3);

        function IdentitySyntax(_ref7) {
            var args = _ref7.args;
            var templates = _ref7.templates;

            _StatementSyntax3.call(this);
            this.type = "identity";
            this.args = args;
            this.templates = templates;
        }

        IdentitySyntax.prototype.compile = function compile(dsl) {
            dsl.evaluate('default', this.templates.default);
        };

        return IdentitySyntax;
    })(_glimmerRuntime.StatementSyntax);

    var RenderInverseIdentitySyntax = (function (_StatementSyntax4) {
        babelHelpers.inherits(RenderInverseIdentitySyntax, _StatementSyntax4);

        function RenderInverseIdentitySyntax(_ref8) {
            var args = _ref8.args;
            var templates = _ref8.templates;

            _StatementSyntax4.call(this);
            this.type = "render-inverse-identity";
            this.args = args;
            this.templates = templates;
        }

        RenderInverseIdentitySyntax.prototype.compile = function compile(dsl) {
            dsl.evaluate('inverse', this.templates.inverse);
        };

        return RenderInverseIdentitySyntax;
    })(_glimmerRuntime.StatementSyntax);

    function equalsElement(element, tagName, attributes, content) {
        QUnit.push(element.tagName === tagName.toUpperCase(), element.tagName.toLowerCase(), tagName, "expect tagName to be " + tagName);
        var expectedAttrs = _glimmerUtil.dict();
        var expectedCount = 0;
        for (var prop in attributes) {
            expectedCount++;
            var expected = attributes[prop];
            var matcher = typeof expected === 'object' && MATCHER in expected ? expected : equalsAttr(expected);
            expectedAttrs[prop] = matcher;
            QUnit.push(expectedAttrs[prop].match(element.getAttribute(prop)), matcher.fail(element.getAttribute(prop)), matcher.fail(element.getAttribute(prop)), "Expected element's " + prop + " attribute " + matcher.expected());
        }
        var actualAttributes = {};
        for (var i = 0, l = element.attributes.length; i < l; i++) {
            actualAttributes[element.attributes[i].name] = element.attributes[i].value;
        }
        if (!(element instanceof HTMLElement)) {
            QUnit.push(element instanceof HTMLElement, null, null, "Element must be an HTML Element, not an SVG Element");
        } else {
            QUnit.push(element.attributes.length === expectedCount, element.attributes.length, expectedCount, "Expected " + expectedCount + " attributes; got " + element.outerHTML);
            if (content !== null) {
                QUnit.push(element.innerHTML === content, element.innerHTML, content, "The element had '" + content + "' as its content");
            }
        }
    }

    var MATCHER = "3d4ef194-13be-4ccf-8dc7-862eea02c93e";
    exports.MATCHER = MATCHER;

    function equalsAttr(expected) {
        return {
            "3d4ef194-13be-4ccf-8dc7-862eea02c93e": true,
            match: function (actual) {
                return expected === actual;
            },
            expected: function () {
                return "to equal " + expected;
            },
            fail: function (actual) {
                return actual + " did not equal " + expected;
            }
        };
    }

    function equals(expected) {
        return {
            "3d4ef194-13be-4ccf-8dc7-862eea02c93e": true,
            match: function (actual) {
                return expected === actual;
            },
            expected: function () {
                return "to equal " + expected;
            },
            fail: function (actual) {
                return actual + " did not equal " + expected;
            }
        };
    }

    function regex(r) {
        return {
            "3d4ef194-13be-4ccf-8dc7-862eea02c93e": true,
            match: function (v) {
                return r.test(v);
            },
            expected: function () {
                return "to match " + r;
            },
            fail: function (actual) {
                return actual + " did not match " + r;
            }
        };
    }

    function classes(expected) {
        return {
            "3d4ef194-13be-4ccf-8dc7-862eea02c93e": true,
            match: function (actual) {
                return actual && expected.split(' ').sort().join(' ') === actual.split(' ').sort().join(' ');
            },
            expected: function () {
                return "to include '" + expected + "'";
            },
            fail: function (actual) {
                return "'" + actual + "'' did not match '" + expected + "'";
            }
        };
    }
});

// Partials

// Syntax Classes

// Concrete Syntax

// References

enifed("glimmer-test-helpers/lib/helpers", ["exports", "simple-html-tokenizer", "glimmer-runtime", "glimmer-compiler"], function (exports, _simpleHtmlTokenizer, _glimmerRuntime, _glimmerCompiler) {
    "use strict";

    exports.compile = compile;
    exports.compileLayout = compileLayout;
    exports.equalInnerHTML = equalInnerHTML;
    exports.equalHTML = equalHTML;
    exports.equalTokens = equalTokens;
    exports.generateSnapshot = generateSnapshot;
    exports.equalSnapshots = equalSnapshots;
    exports.normalizeInnerHTML = normalizeInnerHTML;
    exports.getTextContent = getTextContent;
    exports.strip = strip;
    exports.stripTight = stripTight;

    // For Phantom
    function toObject(val) {
        if (val === null || val === undefined) {
            throw new TypeError('Object.assign cannot be called with null or undefined');
        }
        return Object(val);
    }
    if (typeof Object.assign !== 'function') {
        Object.assign = function (target, source) {
            var from = undefined;
            var to = toObject(target);
            var symbols = undefined;
            for (var s = 1; s < arguments.length; s++) {
                from = Object(arguments[s]);
                for (var key in from) {
                    if (Object.prototype.hasOwnProperty.call(from, key)) {
                        to[key] = from[key];
                    }
                }
                if (Object.getOwnPropertySymbols) {
                    symbols = Object.getOwnPropertySymbols(from);
                    for (var i = 0; i < symbols.length; i++) {
                        if (Object.prototype.propertyIsEnumerable.call(from, symbols[i])) {
                            to[symbols[i]] = from[symbols[i]];
                        }
                    }
                }
            }
            return to;
        };
    }
    var assign = Object.assign;
    exports.assign = assign;
    function isMarker(node) {
        var TextNode = window.Text;
        var Comment = window.Comment;
        if (node instanceof Comment && node.textContent === '') {
            return true;
        }
        if (node instanceof TextNode && node.textContent === '') {
            return true;
        }
        return false;
    }

    function compile(string, options) {
        var js = _glimmerCompiler.precompile(string, options);
        var factory = _glimmerRuntime.templateFactory(JSON.parse(js));
        return factory.create(options.env);
    }

    function compileLayout(string, options) {
        return compile(string, options).asLayout();
    }

    function equalInnerHTML(fragment, html, msg) {
        var actualHTML = normalizeInnerHTML(fragment.innerHTML);
        QUnit.push(actualHTML === html, actualHTML, html, msg);
    }

    function equalHTML(node, html) {
        var fragment = undefined;
        if (!node.nodeType && node.length) {
            fragment = document.createDocumentFragment();
            while (node[0]) {
                fragment.appendChild(node[0]);
            }
        } else {
            fragment = node;
        }
        var div = document.createElement("div");
        div.appendChild(fragment.cloneNode(true));
        equalInnerHTML(div, html);
    }

    function generateTokens(divOrHTML) {
        var div = undefined;
        if (typeof divOrHTML === 'string') {
            div = document.createElement("div");
            div.innerHTML = divOrHTML;
        } else {
            div = divOrHTML;
        }
        return { tokens: _simpleHtmlTokenizer.tokenize(div.innerHTML), html: div.innerHTML };
    }

    function equalTokens(fragment, html) {
        var message = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

        if (fragment.fragment) {
            fragment = fragment.fragment;
        }
        if (html.fragment) {
            html = html.fragment;
        }
        var fragTokens = generateTokens(fragment);
        var htmlTokens = generateTokens(html);
        function normalizeTokens(token) {
            if (token.type === 'StartTag') {
                token.attributes = token.attributes.sort(function (a, b) {
                    if (a[0] > b[0]) {
                        return 1;
                    }
                    if (a[0] < b[0]) {
                        return -1;
                    }
                    return 0;
                });
            }
        }
        fragTokens.tokens.forEach(normalizeTokens);
        htmlTokens.tokens.forEach(normalizeTokens);
        // let msg = "Expected: " + htmlTokens.html + "; Actual: " + fragTokens.html;
        // if (message) { msg += " (" + message + ")"; }
        var equiv = QUnit.equiv(fragTokens.tokens, htmlTokens.tokens);
        if (equiv && fragTokens.html !== htmlTokens.html) {
            deepEqual(fragTokens.tokens, htmlTokens.tokens, message);
        } else {
            QUnit.push(QUnit.equiv(fragTokens.tokens, htmlTokens.tokens), fragTokens.html, htmlTokens.html, message);
        }
        // deepEqual(fragTokens.tokens, htmlTokens.tokens, msg);
    }

    function generateSnapshot(element) {
        var snapshot = [];
        var node = element.firstChild;
        while (node) {
            if (!isMarker(node)) {
                snapshot.push(node);
            }
            node = node.nextSibling;
        }
        return snapshot;
    }

    function equalSnapshots(a, b) {
        strictEqual(a.length, b.length, 'Same number of nodes');
        for (var i = 0; i < b.length; i++) {
            strictEqual(a[i], b[i], 'Nodes are the same');
        }
    }

    // detect side-effects of cloning svg elements in IE9-11
    var ieSVGInnerHTML = (function () {
        if (typeof document === 'undefined' || !document.createElementNS) {
            return false;
        }
        var div = document.createElement('div');
        var node = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
        div.appendChild(node);
        var clone = div.cloneNode(true);
        return clone.innerHTML === '<svg xmlns="http://www.w3.org/2000/svg" />';
    })();

    function normalizeInnerHTML(actualHTML) {
        if (ieSVGInnerHTML) {
            // Replace `<svg xmlns="http://www.w3.org/2000/svg" height="50%" />` with `<svg height="50%"></svg>`, etc.
            // drop namespace attribute
            actualHTML = actualHTML.replace(/ xmlns="[^"]+"/, '');
            // replace self-closing elements
            actualHTML = actualHTML.replace(/<([^ >]+) [^\/>]*\/>/gi, function (tag, tagName) {
                return tag.slice(0, tag.length - 3) + '></' + tagName + '>';
            });
        }
        return actualHTML;
    }

    var isCheckedInputHTML = undefined;
    if (typeof document === 'undefined') {
        exports.isCheckedInputHTML = isCheckedInputHTML = function (element) {};
    } else {
        (function () {
            // detect weird IE8 checked element string
            var checkedInput = document.createElement('input');
            checkedInput.setAttribute('checked', 'checked');
            var checkedInputString = checkedInput.outerHTML;
            exports.isCheckedInputHTML = isCheckedInputHTML = function (element) {
                equal(element.outerHTML, checkedInputString);
            };
        })();
    }
    exports.isCheckedInputHTML = isCheckedInputHTML;

    // check which property has the node's text content
    var textProperty = typeof document === 'object' && document.createElement('div').textContent === undefined ? 'innerText' : 'textContent';

    function getTextContent(el) {
        // textNode
        if (el.nodeType === 3) {
            return el.nodeValue;
        } else {
            return el[textProperty];
        }
    }

    function strip(strings) {
        return strings[0].split('\n').map(function (s) {
            return s.trim();
        }).join(' ');
    }

    function stripTight(strings) {
        return strings[0].split('\n').map(function (s) {
            return s.trim();
        }).join('');
    }
});
//# sourceMappingURL=glimmer-demos.amd.map